﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Custom View class - LabeledTextField
'2016 by Robert W.B. Linn, www.rwblinn.de
'Version 20160215
#Region NOTES
'Example using properties and methods
'	...
'	MainForm.Show
	'Set Properties
'	LabeledTextField1.SetLabelText("Enter:")
'	LabeledTextField1.SetFieldValue("Hello World")
'	'Set Position
'	'To change the customview position after mainform show use callsubdelayed2
'	CallSubDelayed2(LabeledTextField1, "SetWidth", 50)
'	CallSubDelayed2(LabeledTextField1, "SetTop", 80)
'	CallSubDelayed2(LabeledTextField1, "SetLeft", 80)
#End Region

'Custom View Properties: FieldValue as Int, Min and MaxValue as Int, TooltipText as string

#DesignerProperty: Key: LabelText, Displayname: LabelText, Fieldtype: String, Defaultvalue: Text, Description: The LabeledTextField Label
#DesignerProperty: Key: FieldValue, Displayname: FieldValue, Fieldtype: String, Defaultvalue: Value, Description: The LabeledTextField Field

Private Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private mProps As Map
	'The Views
	Private lblField As Label
	Private LabelText As String
	Private tfField As TextField
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	mEventName = vEventName
	mCallBack = vCallback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	mProps = Props
	'Base
	CSSUtils.SetBorder(mBase, 0, fx.Colors.Transparent, 0)

	'Label
	lblField.Initialize("lblField")
	lblField.Style = Lbl.Style
	lblField.Text = mProps.Get("LabelText")
	Base.AddNode(lblField, 0, 0, 200, -1)

	'TextField
	tfField.Initialize("tfField")
	tfField.Style = Lbl.Style
	tfField.Text = mProps.Get("FieldValue")
	Base.AddNode(tfField, 0, 20, 200, -1)
End Sub

Public Sub AddToParent(Parent As Pane, Left As Int, Top As Int, Width As Int, Height As Int)
	mBase.Initialize("mBase")
	'Label
	lblField.Initialize("lblField")
	mBase.AddNode(lblField, 0, 0, 200, -1)
	'TextField
	tfField.Initialize("tfField")
	mBase.AddNode(tfField, 0, 20, 200, -1)
	'
    Parent.AddNode(mBase, Left, Top, Width, Height)
End Sub

'Handle resize of the base - DLTWH
Private Sub Base_Resize (Width As Double, Height As Double)
	lblField.SetLayoutAnimated(0, 2, 0, Width, (Height / 2) - 2)
	tfField.SetLayoutAnimated(0, 2, Height / 2, Width, (Height / 2) - 2)
End Sub

Public Sub SetWidth(Width As Double)
	If Width < 100 Then Width = 100
	mBase.PrefWidth = Width
End Sub

Public Sub SetHeight(Height As Double)
	If Height < 50 Then Height = 50
	mBase.PrefHeight = Height
End Sub

Public Sub SetTop(Top As Double)
	If Top < 0 Then Top = 0
	mBase.Top = Top
End Sub

Public Sub SetLeft(Left As Double)
	If Left < 0 Then Left = 0
	mBase.Left = Left
End Sub

Public Sub SetLabelText(v As String)
	lblField.Text = v
End Sub

Public Sub GetLabelText As String
	Return LabelText
End Sub

Public Sub GetFieldValue As String
	Return tfField.Text
End Sub

Public Sub SetFieldValue(v As String)
	tfField.Text = v
End Sub
